/*
 * Work under Copyright. Licensed under the EUPL.
 * See the project README.md and LICENSE.txt for more information.
 */

package net.dries007.tfc.client.gui;

import net.minecraft.client.gui.inventory.GuiContainer;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.client.resources.I18n;
import net.minecraft.entity.player.InventoryPlayer;
import net.minecraft.inventory.Container;
import net.minecraft.util.ResourceLocation;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

@SideOnly(Side.CLIENT)
public class GuiContainerTFC extends GuiContainer
{
    private final ResourceLocation background;
    private final String translationKey;
    protected InventoryPlayer playerInv;

    public GuiContainerTFC(Container container, InventoryPlayer playerInv, ResourceLocation background, String titleKey)
    {
        super(container);
        this.playerInv = playerInv;
        this.background = background;
        this.translationKey = titleKey;
    }

    @Override
    public void func_73863_a(int mouseX, int mouseY, float partialTicks)
    {
        this.func_146276_q_();
        super.func_73863_a(mouseX, mouseY, partialTicks);
        this.func_191948_b(mouseX, mouseY);
    }

    @Override
    protected void func_146979_b(int mouseX, int mouseY)
    {
        drawSimpleForeground();
    }

    @Override
    protected void func_146976_a(float partialTicks, int mouseX, int mouseY)
    {
        drawSimpleBackground();
    }

    protected void drawSimpleForeground()
    {
        String name = I18n.func_135052_a(translationKey + ".name");
        field_146289_q.func_78276_b(name, field_146999_f / 2 - field_146289_q.func_78256_a(name) / 2, 6, 0x404040);
        field_146289_q.func_78276_b(playerInv.func_145748_c_().func_150260_c(), 8, field_147000_g - 94, 0x404040);
    }

    protected void drawSimpleBackground()
    {
        GlStateManager.func_179131_c(1, 1, 1, 1);
        field_146297_k.func_110434_K().func_110577_a(background);
        int x = (field_146294_l - field_146999_f) / 2;
        int y = (field_146295_m - field_147000_g) / 2;
        func_73729_b(x, y, 0, 0, field_146999_f, field_147000_g);
    }
}
